------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 1.12
--  \   \         Application : Virtex-6 FPGA GTX Transceiver Wizard
--  /   /         Filename : v6_gtx_dual_sfp_112.vhd
-- /___/   /\      
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Instantiation Template
-- Generated by Xilinx Virtex-6 FPGA GTX Transceiver Wizard


--**************************Component Declarations*****************************


component v6_gtx_dual_sfp_112 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTXRESET_SPEEDUP    : integer   := 0 -- Set to 1 to speed up sim reset
);
port
(
    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GTX0  (X0_Y0)

    ------------------------ Loopback and Powerdown Ports ----------------------
    GTX0_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    GTX0_RXCHARISK_OUT                      : out  std_logic;
    GTX0_RXDISPERR_OUT                      : out  std_logic;
    GTX0_RXNOTINTABLE_OUT                   : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GTX0_RXCLKCORCNT_OUT                    : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    GTX0_RXCOMMADET_OUT                     : out  std_logic;
    GTX0_RXENMCOMMAALIGN_IN                 : in   std_logic;
    GTX0_RXENPCOMMAALIGN_IN                 : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    GTX0_RXDATA_OUT                         : out  std_logic_vector(7 downto 0);
    GTX0_RXRESET_IN                         : in   std_logic;
    GTX0_RXUSRCLK_IN                        : in   std_logic;
    GTX0_RXUSRCLK2_IN                       : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GTX0_RXEQMIX_IN                         : in   std_logic_vector(2 downto 0);
    GTX0_RXN_IN                             : in   std_logic;
    GTX0_RXP_IN                             : in   std_logic;
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GTX0_GREFCLKRX_IN                       : in   std_logic;
    GTX0_GTXRXRESET_IN                      : in   std_logic;
    GTX0_MGTREFCLKRX_IN                     : in   std_logic;
    GTX0_NORTHREFCLKRX_IN                   : in   std_logic_vector(1 downto 0);
    GTX0_PERFCLKRX_IN                       : in   std_logic;
    GTX0_PLLRXRESET_IN                      : in   std_logic;
    GTX0_RXPLLLKDET_OUT                     : out  std_logic;
    GTX0_RXPLLREFSELDY_IN                   : in   std_logic_vector(2 downto 0);
    GTX0_RXRESETDONE_OUT                    : out  std_logic;
    GTX0_SOUTHREFCLKRX_IN                   : in   std_logic_vector(1 downto 0);
    ----------------- Receive Ports - RX Polarity Control Ports ----------------
    GTX0_RXPOLARITY_IN                      : in   std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    GTX0_TXCHARISK_IN                       : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GTX0_TXDATA_IN                          : in   std_logic_vector(7 downto 0);
    GTX0_TXOUTCLK_OUT                       : out  std_logic;
    GTX0_TXRESET_IN                         : in   std_logic;
    GTX0_TXUSRCLK_IN                        : in   std_logic;
    GTX0_TXUSRCLK2_IN                       : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GTX0_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    GTX0_TXN_OUT                            : out  std_logic;
    GTX0_TXP_OUT                            : out  std_logic;
    GTX0_TXPOSTEMPHASIS_IN                  : in   std_logic_vector(4 downto 0);
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    GTX0_TXPREEMPHASIS_IN                   : in   std_logic_vector(3 downto 0);
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GTX0_GREFCLKTX_IN                       : in   std_logic;
    GTX0_GTXTXRESET_IN                      : in   std_logic;
    GTX0_NORTHREFCLKTX_IN                   : in   std_logic_vector(1 downto 0);
    GTX0_PERFCLKTX_IN                       : in   std_logic;
    GTX0_SOUTHREFCLKTX_IN                   : in   std_logic_vector(1 downto 0);
    GTX0_TXPLLREFSELDY_IN                   : in   std_logic_vector(2 downto 0);
    GTX0_TXRESETDONE_OUT                    : out  std_logic;
    -------------------- Transmit Ports - TX Polarity Control ------------------
    GTX0_TXPOLARITY_IN                      : in   std_logic;


    
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GTX1  (X0_Y2)

    ------------------------ Loopback and Powerdown Ports ----------------------
    GTX1_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    GTX1_RXCHARISK_OUT                      : out  std_logic;
    GTX1_RXDISPERR_OUT                      : out  std_logic;
    GTX1_RXNOTINTABLE_OUT                   : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GTX1_RXCLKCORCNT_OUT                    : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    GTX1_RXCOMMADET_OUT                     : out  std_logic;
    GTX1_RXENMCOMMAALIGN_IN                 : in   std_logic;
    GTX1_RXENPCOMMAALIGN_IN                 : in   std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    GTX1_RXDATA_OUT                         : out  std_logic_vector(7 downto 0);
    GTX1_RXRESET_IN                         : in   std_logic;
    GTX1_RXUSRCLK_IN                        : in   std_logic;
    GTX1_RXUSRCLK2_IN                       : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GTX1_RXEQMIX_IN                         : in   std_logic_vector(2 downto 0);
    GTX1_RXN_IN                             : in   std_logic;
    GTX1_RXP_IN                             : in   std_logic;
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GTX1_GREFCLKRX_IN                       : in   std_logic;
    GTX1_GTXRXRESET_IN                      : in   std_logic;
    GTX1_MGTREFCLKRX_IN                     : in   std_logic;
    GTX1_NORTHREFCLKRX_IN                   : in   std_logic_vector(1 downto 0);
    GTX1_PERFCLKRX_IN                       : in   std_logic;
    GTX1_PLLRXRESET_IN                      : in   std_logic;
    GTX1_RXPLLLKDET_OUT                     : out  std_logic;
    GTX1_RXPLLREFSELDY_IN                   : in   std_logic_vector(2 downto 0);
    GTX1_RXRESETDONE_OUT                    : out  std_logic;
    GTX1_SOUTHREFCLKRX_IN                   : in   std_logic_vector(1 downto 0);
    ----------------- Receive Ports - RX Polarity Control Ports ----------------
    GTX1_RXPOLARITY_IN                      : in   std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    GTX1_TXCHARISK_IN                       : in   std_logic;
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GTX1_TXDATA_IN                          : in   std_logic_vector(7 downto 0);
    GTX1_TXOUTCLK_OUT                       : out  std_logic;
    GTX1_TXRESET_IN                         : in   std_logic;
    GTX1_TXUSRCLK_IN                        : in   std_logic;
    GTX1_TXUSRCLK2_IN                       : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GTX1_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    GTX1_TXN_OUT                            : out  std_logic;
    GTX1_TXP_OUT                            : out  std_logic;
    GTX1_TXPOSTEMPHASIS_IN                  : in   std_logic_vector(4 downto 0);
    --------------- Transmit Ports - TX Driver and OOB signalling --------------
    GTX1_TXPREEMPHASIS_IN                   : in   std_logic_vector(3 downto 0);
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GTX1_GREFCLKTX_IN                       : in   std_logic;
    GTX1_GTXTXRESET_IN                      : in   std_logic;
    GTX1_NORTHREFCLKTX_IN                   : in   std_logic_vector(1 downto 0);
    GTX1_PERFCLKTX_IN                       : in   std_logic;
    GTX1_SOUTHREFCLKTX_IN                   : in   std_logic_vector(1 downto 0);
    GTX1_TXPLLREFSELDY_IN                   : in   std_logic_vector(2 downto 0);
    GTX1_TXRESETDONE_OUT                    : out  std_logic;
    -------------------- Transmit Ports - TX Polarity Control ------------------
    GTX1_TXPOLARITY_IN                      : in   std_logic


);
end component;










    ----------------------------- The GTX Wrapper -----------------------------


    v6_gtx_dual_sfp_112_i : v6_gtx_dual_sfp_112
    generic map
    (
        WRAPPER_SIM_GTXRESET_SPEEDUP    =>      1
    )
    port map
    (
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GTX0  (X0Y0)

        ------------------------ Loopback and Powerdown Ports ----------------------
        GTX0_LOOPBACK_IN                =>      ,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        GTX0_RXCHARISK_OUT              =>      ,
        GTX0_RXDISPERR_OUT              =>      ,
        GTX0_RXNOTINTABLE_OUT           =>      ,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GTX0_RXCLKCORCNT_OUT            =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        GTX0_RXCOMMADET_OUT             =>      ,
        GTX0_RXENMCOMMAALIGN_IN         =>      ,
        GTX0_RXENPCOMMAALIGN_IN         =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        GTX0_RXDATA_OUT                 =>      ,
        GTX0_RXRESET_IN                 =>      ,
        GTX0_RXUSRCLK_IN                =>      ,
        GTX0_RXUSRCLK2_IN               =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTX0_RXEQMIX_IN                 =>      ,
        GTX0_RXN_IN                     =>      ,
        GTX0_RXP_IN                     =>      ,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        GTX0_GREFCLKRX_IN               =>      ,
        GTX0_GTXRXRESET_IN              =>      ,
        GTX0_MGTREFCLKRX_IN             =>      ,
        GTX0_NORTHREFCLKRX_IN           =>      ,
        GTX0_PERFCLKRX_IN               =>      ,
        GTX0_PLLRXRESET_IN              =>      ,
        GTX0_RXPLLLKDET_OUT             =>      ,
        GTX0_RXPLLREFSELDY_IN           =>      ,
        GTX0_RXRESETDONE_OUT            =>      ,
        GTX0_SOUTHREFCLKRX_IN           =>      ,
        ----------------- Receive Ports - RX Polarity Control Ports ----------------
        GTX0_RXPOLARITY_IN              =>      ,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        GTX0_TXCHARISK_IN               =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GTX0_TXDATA_IN                  =>      ,
        GTX0_TXOUTCLK_OUT               =>      ,
        GTX0_TXRESET_IN                 =>      ,
        GTX0_TXUSRCLK_IN                =>      ,
        GTX0_TXUSRCLK2_IN               =>      ,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTX0_TXDIFFCTRL_IN              =>      ,
        GTX0_TXN_OUT                    =>      ,
        GTX0_TXP_OUT                    =>      ,
        GTX0_TXPOSTEMPHASIS_IN          =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        GTX0_TXPREEMPHASIS_IN           =>      ,
        ----------------------- Transmit Ports - TX PLL Ports ----------------------
        GTX0_GREFCLKTX_IN               =>      ,
        GTX0_GTXTXRESET_IN              =>      ,
        GTX0_NORTHREFCLKTX_IN           =>      ,
        GTX0_PERFCLKTX_IN               =>      ,
        GTX0_SOUTHREFCLKTX_IN           =>      ,
        GTX0_TXPLLREFSELDY_IN           =>      ,
        GTX0_TXRESETDONE_OUT            =>      ,
        -------------------- Transmit Ports - TX Polarity Control ------------------
        GTX0_TXPOLARITY_IN              =>      ,


        --_____________________________________________________________________
        --_____________________________________________________________________
        --GTX1  (X0Y2)

        ------------------------ Loopback and Powerdown Ports ----------------------
        GTX1_LOOPBACK_IN                =>      ,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        GTX1_RXCHARISK_OUT              =>      ,
        GTX1_RXDISPERR_OUT              =>      ,
        GTX1_RXNOTINTABLE_OUT           =>      ,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GTX1_RXCLKCORCNT_OUT            =>      ,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        GTX1_RXCOMMADET_OUT             =>      ,
        GTX1_RXENMCOMMAALIGN_IN         =>      ,
        GTX1_RXENPCOMMAALIGN_IN         =>      ,
        ------------------- Receive Ports - RX Data Path interface -----------------
        GTX1_RXDATA_OUT                 =>      ,
        GTX1_RXRESET_IN                 =>      ,
        GTX1_RXUSRCLK_IN                =>      ,
        GTX1_RXUSRCLK2_IN               =>      ,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTX1_RXEQMIX_IN                 =>      ,
        GTX1_RXN_IN                     =>      ,
        GTX1_RXP_IN                     =>      ,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        GTX1_GREFCLKRX_IN               =>      ,
        GTX1_GTXRXRESET_IN              =>      ,
        GTX1_MGTREFCLKRX_IN             =>      ,
        GTX1_NORTHREFCLKRX_IN           =>      ,
        GTX1_PERFCLKRX_IN               =>      ,
        GTX1_PLLRXRESET_IN              =>      ,
        GTX1_RXPLLLKDET_OUT             =>      ,
        GTX1_RXPLLREFSELDY_IN           =>      ,
        GTX1_RXRESETDONE_OUT            =>      ,
        GTX1_SOUTHREFCLKRX_IN           =>      ,
        ----------------- Receive Ports - RX Polarity Control Ports ----------------
        GTX1_RXPOLARITY_IN              =>      ,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        GTX1_TXCHARISK_IN               =>      ,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GTX1_TXDATA_IN                  =>      ,
        GTX1_TXOUTCLK_OUT               =>      ,
        GTX1_TXRESET_IN                 =>      ,
        GTX1_TXUSRCLK_IN                =>      ,
        GTX1_TXUSRCLK2_IN               =>      ,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTX1_TXDIFFCTRL_IN              =>      ,
        GTX1_TXN_OUT                    =>      ,
        GTX1_TXP_OUT                    =>      ,
        GTX1_TXPOSTEMPHASIS_IN          =>      ,
        --------------- Transmit Ports - TX Driver and OOB signalling --------------
        GTX1_TXPREEMPHASIS_IN           =>      ,
        ----------------------- Transmit Ports - TX PLL Ports ----------------------
        GTX1_GREFCLKTX_IN               =>      ,
        GTX1_GTXTXRESET_IN              =>      ,
        GTX1_NORTHREFCLKTX_IN           =>      ,
        GTX1_PERFCLKTX_IN               =>      ,
        GTX1_SOUTHREFCLKTX_IN           =>      ,
        GTX1_TXPLLREFSELDY_IN           =>      ,
        GTX1_TXRESETDONE_OUT            =>      ,
        -------------------- Transmit Ports - TX Polarity Control ------------------
        GTX1_TXPOLARITY_IN              =>      


    );



    -----------------------Dedicated GTX Reference Clock Inputs ---------------
    -- Each dedicated refclk you are using in your design will need its own IBUFDS_GTXE1 instance
    
    q0_clk0_refclk_ibufds_i : IBUFDS_GTXE1
    port map
    (
        O                               =>      ,
        ODIV2                           =>      ,
        CEB                             =>      ,
        I                               =>      ,  -- Connect to package pin AK6
        IB                              =>        -- Connect to package pin AK5
    );












